#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>

int main( int argc, char** argv )
{
    CvCapture* capture = cvCaptureFromCAM(0);

	if(capture == 0)
    {
        fprintf(stderr, "Could not initialize capturing...\n");
        return -1;
    }

    cvNamedWindow("Output");

	IplImage* image = cvCreateImage(cvSize(320, 240), 8, 3);
	IplImage* image2 = cvCreateImage(cvSize(320, 240), 8, 1);
	IplImage* image3 = cvCreateImage(cvSize(320, 240), 8, 3);
	IplImage* reference = cvCreateImage(cvSize(320, 240), 8, 3);

    while(true)
    {
        IplImage* frame = cvQueryFrame(capture);

        if(frame == 0)
		{
            break;
		}

		cvAbsDiff(frame, reference, image);
		cvSmooth(image, image3, CV_MEDIAN, 5);
		cvInRangeS(image3, cvScalar(5, 5, 5), cvScalar(255, 255, 255), image2);

		// Turn the image to conform to the input
		image2->origin = frame->origin;

		cvShowImage("Output", image2);

		// cvWaitKey is required to let OpenCV's user interface "breathe".
		int c = cvWaitKey(10);
		if(c == 's')
		{
			cvCopy(frame, reference);
		}
    }

	cvDestroyWindow("Output");
	cvReleaseCapture(&capture);
	cvReleaseImage(&image);
	cvReleaseImage(&image2);
	cvReleaseImage(&image3);
	cvReleaseImage(&reference);

    return 0;
}